/* Trabalho 1 de Sc1
   Flavio Magacho Filho - 9416719
   Juliana Imperial     - 9714169
   Silvia Carla Moreira - 9416382
   
   Versao 1.0
   Trab1.c
*/

#include "semaf.h"
#include "trab1.h"

int mutex;                     /* exclusao mutua */
int Sem_leitor;
int Sem_escritor;
char* rc;                /* contador */
int  *array, *indice;


void main(int num_args, char **v_args)
{//declarar memoria compartilhada
   int   Leitores   = 0,
         Escritores = 0,
         tempo      = 0;
   int   memfile;
   int pid;
   int i;

   if (num_args != 4)
   {
       printf("Erro nos parametros!!\n");
       exit( 0 );
   }

   Leitores   = atoi (v_args[1]);
   Escritores = atoi (v_args[2]);
   tempo      = atoi (v_args[3]);

   if ((Leitores < 0) || (Escritores < 0) || (tempo < 0))
   {
       printf("Erro nos parametros!!\n");
       printf("trab1 [Nmero de Leitores] [Nmero de Escritores] [Tempo de Execuo(s)]\n");
       exit( 0 );
   }

   printf("CRIANDO SEMAFOROS...\n");
   mutex        = sem_create(1);  /* inicializando mutex */
   if (mutex == -1)
   {
       printf("Mutex nao criado.\n");
       exit( 0 );
   }
   Sem_leitor   = sem_create(1);  /* inicializando semaforo leitores */
   if (Sem_leitor == -1)
   {
       printf("Sem_leitor nao criado.\n");
       exit( 0 );
   }
   Sem_escritor = sem_create(1);  /* inicializando semaforo escritores */
   if (Sem_escritor == -1)
   {
       printf("Sem_escritor nao criado.\n");
       exit( 0 );
   }
   printf("SEMAFOROS CRIADOS.\n");

   /* Criando memoria compartilhada */
   memfile = open( "temp", O_RDWR );/* Abre o arquivo */

   /* Criando a rea compartilhada na memoria */
   rc      = mmap(NULL, sizeof(int), PROT_READ | PROT_WRITE, MAP_SHARED, memfile,0);
   assert(rc>=0);
   close(memfile);
   *rc = 0;

   array = (int *) malloc(sizeof(int)*(Leitores + Escritores));
   assert(array != NULL);
   indice = array;

   //fork de leitores
   for (i=0; i< Leitores; i++)/*fork de leitores*/
   {
       assert((pid=fork())>=0);
       if (pid == 0) /* processo e filho, inicializa leitores */
       {
	    leitor();
	    exit( 0 );	
       }
	else
       {
            printf("Processo Leitor(%d) criado.\n", pid);
            *indice = pid; /* Grava os pids no vetor */
            indice++;	
       }	
   }

   //fork de escritores
   for (i=0; i<Escritores; i++)
   {
       assert((pid=fork())>=0);
       if (pid == 0) /* processo e filho, inicializa escritores */
       {
	    escritor();
	    exit( 0 );	
       }
	else
       {
	    printf("Processo Escritor(%d) criado.\n", pid);
            *indice = pid; /* Grava os pids no vetor */
            indice++;	
       }	
   }

   sleep(tempo);

   printf("Matando Processos...\n");
   while (indice > array)
   {
	 indice--;
         printf("Matando processo %d\n", *indice);
         kill(*indice,9);
   }

   printf("Destruindo semaforos ...\n");
   sem_destroy(mutex);
   sem_destroy(Sem_leitor);
   sem_destroy(Sem_escritor);
   printf("Termino da execucao!\n");

   exit ( 0 );
} /* Fim do main */


void leitor(void)
{
   while (TRUE){    /* loop infinito */
      pre_ler();
      ler_memoria();
      pos_ler();
      usar_dado_memoria();
   }
}   


void escritor(void)
{
   while (TRUE){    /* loop infinito */
      pensar();
      pre_escrever();
      escrever_memoria();
      pos_escrever();
   }
}



void pre_ler(void)
{
   sem_p(Sem_leitor);
   sem_p(mutex);
   (*rc)++;

   if ((*rc) ==1)
      sem_p(Sem_escritor);
   sem_v(mutex);
   sem_v(Sem_leitor);
}



void pos_ler(void)
{

   sem_p(mutex);
   (*rc)--;

   if (*rc == 0)
      sem_v(Sem_escritor);
   sem_v(mutex);
}



void pre_escrever(void)
{
   sem_p(Sem_leitor);
   sem_p(Sem_escritor);
}


void pos_escrever(void)
{
   sem_v(Sem_escritor);
   sem_v(Sem_leitor);
}



void pensar(void)
{
   int time;

   srand(getpid()*PRIMO *11);
   time = (int) (rand()/RAND_MAX)* 100000;
   printf("PID %d(Escritor) Esta pensando.\n", getpid());
   usleep(time);
   printf("PID %d(Escritor) Acabou de  pensar.\n", getpid());
}


void ler_memoria(void)
{

   int time;

   srand(getpid()*PRIMO *3);
   time = (int) (rand()/RAND_MAX)* 10000;
   printf("PID %d Esta lendo memoria.\n", getpid());
   usleep(time);
}


void escrever_memoria(void)
{
   int time;

   srand(getpid()*PRIMO *7);
   time = (int) (rand()/RAND_MAX)* 10000;
   printf("PID %d Esta escrevendo na memoria.\n", getpid());
   usleep(time);
}


void usar_dado_memoria(void)
{
   int time;

   srand(getpid()*PRIMO *5);
   time = (int) (rand()/RAND_MAX)* 100000;
   printf("PID %d (Leitor) Esta usando dados da memoria.\n", getpid());
   usleep(time);
   printf("PID %d(Leitor) Acabou de usar dados.\n", getpid());
}